#include <Windows.h>

#include "BonTuner.h"


// ~[ebNX
#define MUTEX_NAME			TEXT("Global\\BonDriver_Seg_")

//TSMobt@
#define MAX_BUFF_COUNT 500


#pragma warning( disable : 4273 )
extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}
#pragma warning( default : 4273 )

//R[obNpO[oϐ
vector<TS_DATA*> g_TsBuff;
DWORD g_dwRecv1Sec;
HANDLE g_hOnStreamEvent;
CRITICAL_SECTION g_CriticalSection;

CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

//TSMR[obN
static void __stdcall RecvProc( void* pDrv, BYTE* pbBuff, int iSize );
void __stdcall RecvProc( void* pDrv, BYTE* pbBuff, int iSize)
{
	static DWORD dwRecvSize = 0;
	static DWORD dwTickCount = 0;
	if( iSize > 0 ){
		TS_DATA* pItem = new TS_DATA;
		pItem->dwSize = iSize;
		pItem->pbBuff = new BYTE[iSize];
		memcpy(pItem->pbBuff, pbBuff, pItem->dwSize);

		::EnterCriticalSection(&g_CriticalSection);
		if( g_TsBuff.size() > MAX_BUFF_COUNT ){
			while( g_TsBuff.size() > MAX_BUFF_COUNT ){
				SAFE_DELETE(g_TsBuff[0]);
				g_TsBuff.erase( g_TsBuff.begin() );
			}
		}
		g_TsBuff.push_back(pItem);
		::LeaveCriticalSection(&g_CriticalSection);
		SetEvent(g_hOnStreamEvent);

		//rbg[gvZp
		DWORD dwTick = GetTickCount();
		if( dwTick - dwTickCount > 1000 ){
			g_dwRecv1Sec = dwRecvSize + pItem->dwSize;
			dwTickCount = dwTick;
			dwRecvSize = 0;
		}else if( dwTick < dwTickCount ){
			dwTickCount = dwTick;
			dwRecvSize = 0;
		}else{
			dwRecvSize += pItem->dwSize;
		}
	}
	return ;
}

CBonTuner::CBonTuner()
{
	m_pThis = this;

	m_pDrv = NULL;
	m_dwCurSpace = 0;
	m_dwCurChannel = 0;
	m_hMutex = NULL;
	g_hOnStreamEvent = NULL;

	m_LastBuff = NULL;
	g_dwRecv1Sec = 0;

	::InitializeCriticalSection(&g_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	CloseTuner();

	::DeleteCriticalSection(&g_CriticalSection);

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner(void)
{
	if( m_pDrv != NULL ){
		CloseTuner();
	}
	//DLL[h
	if( cSegDll.LoadDLL() == FALSE ){
		return FALSE;
	}
	//`[i[`FbN
	int iCount = cSegDll.GetTunerCount();
	if( iCount <= 0 ){
		return FALSE;
	}

	//ID
	char szID[512] = "";
	int iIndex = -1;
	for( int i=0; i<iCount; i++ ){
		WCHAR wszKey[64] = L"";
		wsprintf( wszKey, L"%s_%d", MUTEX_NAME, i );
		HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, wszKey);
		if(hMutex){
			// Ƀ`[i͊JĂ
			::CloseHandle(hMutex);
		}else{
			// `[i͊JĂȂ
			cSegDll.GetTunerID(i, szID, 512);
			iIndex = i;
		}
	}
	//󂫂ȂH
	if( iIndex == -1 ){
		return FALSE;
	}

	//N
	try{
		m_pDrv = cSegDll.MakeDriverInstance();
		if( m_pDrv == NULL ){
			return FALSE;
		}
		//R[obNݒ
		cSegDll.SetReceiveTSCallback( m_pDrv, RecvProc );

		//Activate
		if( cSegDll.Activate(m_pDrv, szID) == 0 ){
			cSegDll.FreeDriverInstance(m_pDrv);
			cSegDll.UnLoadDLL();
			m_pDrv = NULL;
			return FALSE;
		}

		//`l
		SetChannel(0,0);

		//Cxg
		g_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);

		// ~[ebNX쐬
		WCHAR wszKey[64] = L"";
		wsprintf( wszKey, L"%s_%d", MUTEX_NAME, iIndex );
		m_hMutex = ::CreateMutex(NULL, TRUE, wszKey);
		if( m_hMutex == NULL ){
			CloseTuner();
			return FALSE;
		}
	}catch(...){
		CloseTuner();
		return FALSE;
	}

	return TRUE;
}

void CBonTuner::CloseTuner(void)
{
	// CxgJ
	::CloseHandle(g_hOnStreamEvent);
	g_hOnStreamEvent = NULL;

	//DLL
	if( m_pDrv != NULL ){
		cSegDll.Deactivate(m_pDrv);
//		cSegDll.FreeDriverInstance(m_pDrv);
		cSegDll.UnLoadDLL();
		m_pDrv = NULL;
	}

	//`l
	m_dwCurSpace = 0;
	m_dwCurChannel = 0;

	g_dwRecv1Sec = 0;

	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
	}

	//obt@
	::EnterCriticalSection(&g_CriticalSection);
	if( m_LastBuff != NULL ){
		SAFE_DELETE(m_LastBuff);
	}
	for( int i=0; i<(int)g_TsBuff.size(); i++ ){
		SAFE_DELETE(g_TsBuff[i])
	}
	g_TsBuff.clear();
	::LeaveCriticalSection(&g_CriticalSection);
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	return FALSE;
}

const float CBonTuner::GetSignalLevel(void)
{
	float fBitRate = 0;
	fBitRate = ((float)g_dwRecv1Sec/(1024*1024))*8;
	return fBitRate;
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	if( g_hOnStreamEvent == NULL ){
		return WAIT_ABANDONED;
	}
	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(g_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\
			return dwRet;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
	}
}

const DWORD CBonTuner::GetReadyCount(void)
{
	DWORD dwCount = 0;
	::EnterCriticalSection(&g_CriticalSection);
	dwCount = (DWORD)g_TsBuff.size();
	::LeaveCriticalSection(&g_CriticalSection);
	return dwCount;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
		}
		return TRUE;
	}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	::EnterCriticalSection(&g_CriticalSection);
	if( m_LastBuff != NULL ){
		SAFE_DELETE(m_LastBuff);
	}
	BOOL bRet = TRUE;
	if( g_TsBuff.size() != 0 ){
		m_LastBuff = g_TsBuff[0];
		g_TsBuff.erase( g_TsBuff.begin() );

		*pdwSize = m_LastBuff->dwSize;
		*ppDst = m_LastBuff->pbBuff;
		*pdwRemain = (DWORD)g_TsBuff.size();
	}else{
		*pdwSize = 0;
		*pdwRemain = 0;
		bRet = FALSE;
	}
	::LeaveCriticalSection(&g_CriticalSection);
	return bRet;
}

void CBonTuner::PurgeTsStream(void)
{
	//obt@
	::EnterCriticalSection(&g_CriticalSection);
	if( m_LastBuff != NULL ){
		SAFE_DELETE(m_LastBuff);
	}
	for( int i=0; i<(int)g_TsBuff.size(); i++ ){
		SAFE_DELETE(g_TsBuff[i])
	}
	g_TsBuff.clear();
	::LeaveCriticalSection(&g_CriticalSection);

	g_dwRecv1Sec = 0;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	return TEXT("SegDriver_hdus");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	return FALSE;
}
	
LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	switch(dwSpace){
		case 0:
			return TEXT("nfWiUHFj");
		case 1:
			return TEXT("nfWiP[uj");
		default:
			return NULL;		
	}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	static const TCHAR aszChannelName[][16] = 
	{
		TEXT("13ch"), TEXT("14ch"), TEXT("15ch"), TEXT("16ch"), TEXT("17ch"), TEXT("18ch"), TEXT("19ch"),
		TEXT("20ch"), TEXT("21ch"), TEXT("22ch"), TEXT("23ch"), TEXT("24ch"), TEXT("25ch"), TEXT("26ch"), TEXT("27ch"), TEXT("28ch"), TEXT("29ch"),
		TEXT("30ch"), TEXT("31ch"), TEXT("32ch"), TEXT("33ch"), TEXT("34ch"), TEXT("35ch"), TEXT("36ch"), TEXT("37ch"), TEXT("38ch"), TEXT("39ch"), 
		TEXT("40ch"), TEXT("41ch"), TEXT("42ch"), TEXT("43ch"), TEXT("44ch"), TEXT("45ch"), TEXT("46ch"), TEXT("47ch"), TEXT("48ch"), TEXT("49ch"), 
		TEXT("50ch"), TEXT("51ch"), TEXT("52ch"), TEXT("53ch"), TEXT("54ch"), TEXT("55ch"), TEXT("56ch"), TEXT("57ch"), TEXT("58ch"), TEXT("59ch"), 
		TEXT("60ch"), TEXT("61ch"), TEXT("62ch")
	};
	static const TCHAR aszCableChannelName[][16] = 
	{
		TEXT("C13ch"), TEXT("C14ch"), TEXT("C15ch"), TEXT("C16ch"), TEXT("C17ch"), TEXT("C18ch"), TEXT("C19ch"),
		TEXT("C20ch"), TEXT("C21ch"), TEXT("C22ch"), TEXT("C23ch"), TEXT("C24ch"), TEXT("C25ch"), TEXT("C26ch"), TEXT("C27ch"), TEXT("C28ch"), TEXT("C29ch"),
		TEXT("C30ch"), TEXT("C31ch"), TEXT("C32ch"), TEXT("C33ch"), TEXT("C34ch"), TEXT("C35ch"), TEXT("C36ch"), TEXT("C37ch"), TEXT("C38ch"), TEXT("C39ch"), 
		TEXT("C40ch"), TEXT("C41ch"), TEXT("C42ch"), TEXT("C43ch"), TEXT("C44ch"), TEXT("C45ch"), TEXT("C46ch"), TEXT("C47ch"), TEXT("C48ch"), TEXT("C49ch"), 
		TEXT("C50ch"), TEXT("C51ch"), TEXT("C52ch"), TEXT("C53ch"), TEXT("C54ch"), TEXT("C55ch"), TEXT("C56ch"), TEXT("C57ch"), TEXT("C58ch"), TEXT("C59ch"), 
		TEXT("C60ch"), TEXT("C61ch"), TEXT("C62ch"), TEXT("C63ch")
	};
	if( dwSpace == 0 ){
		if( dwChannel <= 62-13 ){
			return aszChannelName[dwChannel];
		}
	}else if( dwSpace == 1 ){
		if( dwChannel <= 63-13 ){
			return aszCableChannelName[dwChannel];
		}
	}

	return NULL;
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!EnumChannelName(dwSpace, dwChannel))return FALSE;

	if( m_pDrv == NULL ){
		return FALSE;
	}

	//gϊ
	int iFreq = 0;
	if( dwSpace == 0 ){
		//UHF
		iFreq = 473000 + 6000 * dwChannel;
	}else{
		//P[u
		if( dwChannel <= 22-13 ){
			iFreq = 111000 + 6000 * dwChannel;
		}else{
			iFreq = 225000 + 6000 * (dwChannel-10);
		}
	}
	//CHZbg
	cSegDll.Tune(m_pDrv, iFreq );

	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	PurgeTsStream();

	return TRUE;
}
	
const DWORD CBonTuner::GetCurSpace(void)
{
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	return m_dwCurChannel;
}

void CBonTuner::Release()
{
	delete this;
}
